#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include "fitsio.h"
#include "fitsdebug.h"
#include "utilities.h"

int main(void);

int main() {

  fd_file file;
  char filename[MAXSTRLEN] = "fd_test.fits",
    tablename[MAXSTRLEN] = "test table";
  /* char filename[MAXSTRLEN] = "/data/aped/ronnieh/pse/apec/testing/ionbal.FITS",
     tablename[MAXSTRLEN] = "Ionbalance"; */
  int status, flush, supersede, tabletype, ncol;

  short    sht[3]      = { 1, 2, 3};
  int      intt[1]      = { 1};
  int      inttt       = 1;
  long     lng[3]      = {111100, 222200, 333300};
  float    flt[3]      = {1.0, 2.0, 3.0};
  double   dbl[3]      = {1.0000001, 2.0000002, 3.0000003};
  char    *chr[3]      = {"a", "b", "c"};
  char    *chr10[3]    = {"1234567890", "abcdefghij", "-=-=-=-=++"};
  unsigned char byt[3] = {10, 20, 120}; 

  msg_set_verbose(3);

  /* initialize variables */
  status = 0;
  flush = 1;
  supersede = 1;
  ncol = 6;
  tabletype = BINARY_TBL;
  
  msg_message(3,"Ready to start\n");

  if (fd_create_file(&file,filename, tabletype, tablename, 
		     &status, flush, supersede, ncol,
		     "byte[3]", "column 1", "unit column 1", 
		     "short[3]", "column 2a", "unit column 2", 
		     "int", "column 2b", "unit column 2", 
		     "long[3]", "column 2c", "unit column 2", 
		     "float[3]", "column 3a", "unit column 3", 
		     "double[3]", "column 3b", "unit column 3")) {
    fd_err_message(status);
  } 
  
  fd_write_row(&file, byt, sht, inttt, lng, flt, dbl);
  fd_write_rows(&file, 1, byt, sht, intt, lng, flt, dbl);
  fd_print_fd_file(&file);

  fd_print_rows(stdout, &file, FD_ROW_START, FD_ROW_END);

  /* if (fd_open_file(&file,filename, tablename, 
		   &status, flush)) {
    fd_err_message(status);
  }  

  fd_print_fd_file(&file); 
  fd_print_rows(stdout, &file, FD_ROW_START, FD_ROW_END); 
  */

  if (fd_exit_file(&file,&status)) {
    fd_err_message(status);
  }
  return 1;

}
	

