#include <stdlib.h>
#include <stdio.h>

#include "messages.h"
#include "apec.h"

double calc_free_particles(double abund[]) {

  /* Returns number of free particles per nuclei */
  /* For fully-ionized H, He, there are 2 particles per H, */
  /* and 3 for He (which has only 10% of the abundance), */
  /* so (2*1 + 3*0.1)/(1.1) =  2.090909 */

  return (2*abund[1] + 3*abund[2])/(abund[1] + abund[2]); 
  
}
