;
;  Read the data
;
atomdb = getenv('ATOMDB')
if (n_elements(line) eq 0) then $
  read_linelist,atomdb+'/apec_line.fits',line,t1,n1,l1
if (n_elements(rsline) eq 0) then $
  read_linelist,'RS93_line.fits',rsline,t2,n2,l2
if (n_elements(coco) eq 0) then $
  read_coco,atomdb+'/apec_coco.fits',coco,t3,n3,l3
if (n_elements(rscoco) eq 0) then $
  read_coco,'RS93_coco.fits',rscoco,t4,n4,l4

;  Now, plot up some lines: O VII, O VIII, Fe XXV, Fe XXVI
;
o7_r_apec  = extract_line(line, 8, 7, 1, 7, t_o7_r,/actual)
o7_i1_apec = extract_line(line, 8, 7, 1, 5, t_o7_i1,/actual)
o7_i2_apec = extract_line(line, 8, 7, 1, 6, t_o7_i2,/actual)
o7_f_apec  = extract_line(line, 8, 7, 1, 2, t_o7_f,/actual)

o8_la1_apec = extract_line(line, 8, 8, 1, 3, t_o8_la1,/actual)
o8_la2_apec = extract_line(line, 8, 8, 1, 4, t_o8_la2,/actual)
o8_lb1_apec = extract_line(line, 8, 8, 1, 6, t_o8_lb1,/actual)
o8_lb2_apec = extract_line(line, 8, 8, 1, 7, t_o8_lb2,/actual)

o6_r1_apec = extract_line(line, 8, 6, 1, 2, t_o6_r1,/actual)
o6_r2_apec = extract_line(line, 8, 6, 1, 3, t_o6_r2,/actual)

o7_r_rs93 = select_line(rsline, 8, 7, 21.60)
o7_i_rs93 = select_line(rsline, 8, 7, 21.80)
o7_f_rs93 = select_line(rsline, 8, 7, 22.10)

o8_la_rs93 = select_line(rsline, 8, 8, 18.97)
o8_lb_rs93 = select_line(rsline, 8, 8, 16.01)

fe25_r_apec  = extract_line(line, 26, 25, 1, 7, t_fe25_r,/actual)
fe25_i1_apec = extract_line(line, 26, 25, 1, 5, t_fe25_i1,/actual)
fe25_i2_apec = extract_line(line, 26, 25, 1, 6, t_fe25_i2,/actual)
fe25_f_apec  = extract_line(line, 26, 25, 1, 2, t_fe25_f,/actual)

fe26_la1_apec = extract_line(line, 26, 26, 1, 3, t_fe26_la1,/actual)
fe26_la2_apec = extract_line(line, 26, 26, 1, 4, t_fe26_la2,/actual)
fe26_lb1_apec = extract_line(line, 26, 26, 1, 6, t_fe26_lb1,/actual)
fe26_lb2_apec = extract_line(line, 26, 26, 1, 7, t_fe26_lb2,/actual)

fe25_r_rs93 = select_line(rsline, 26, 25, 1.85)
fe25_i_rs93 = select_line(rsline, 26, 25, 1.859)
fe25_f_rs93 = select_line(rsline, 26, 25, 1.867)

fe26_la_rs93 = select_line(rsline, 26, 26, 1.78)
fe26_lb_rs93 = select_line(rsline, 26, 26, 1.50)

!xtitle = 'Temperature'
!ytitle = 'Line Power (photons cm!E3!N s!E-1!N)'
set_plot,'ps'
device,filename='Lines_O_VII.ps'
!mtitle = 'O VII Lines' 
plot_oi,t_o7_r,o7_r_apec,thick=2,xrange=[1.e5,1.e8]
oplot, o7_r_rs93.temperature,o7_r_rs93.epsilon,linestyle=3
oplot,t_o7_i1,o7_i1_apec,linestyle=1,thick=2
oplot, o7_i_rs93.temperature,o7_i_rs93.epsilon,linestyle=3
oplot,t_o7_f,o7_f_apec,linestyle=2,thick=2
oplot, o7_f_rs93.temperature,o7_f_rs93.epsilon,linestyle=3
legend,['R','I','F','RS93'],linestyle=[0,1,2,3],box=0,/top,/right
device,/close

device,filename='Lines_Fe_XXV.ps'
!mtitle = 'Fe XXV Lines' 
plot_oi,t_fe25_r,fe25_r_apec
oplot, fe25_r_rs93.temperature,fe25_r_rs93.epsilon,linestyle=3
oplot,t_fe25_i1,fe25_i1_apec,linestyle=1
oplot, fe25_i_rs93.temperature,fe25_i_rs93.epsilon,linestyle=3
oplot,t_fe25_f,fe25_f_apec,linestyle=2
oplot, fe25_f_rs93.temperature,fe25_f_rs93.epsilon,linestyle=3
legend,['R','I','F','RS93'],linestyle=[0,1,2,3],box=0,/top,/right
device,/close

device,filename='Lines_O_VIII.ps'
!mtitle = 'O VIII Lines' 
plot_oi,t_o8_la1,o8_la1_apec+o8_la2_apec,thick=2,xrange=[1.e6,1.e8]
oplot, o8_la_rs93.temperature,o8_la_rs93.epsilon,linestyle=3
oplot,t_o8_lb1,o8_lb1_apec+o8_lb2_apec,linestyle=1,thick=2
oplot, o8_lb_rs93.temperature,o8_lb_rs93.epsilon,linestyle=3
legend,['LyA','LyB','RS93'],linestyle=[0,1,3],box=0,/top,/right
device,/close

device,filename='Lines_Fe_XXVI.ps'
!mtitle = 'Fe XXVI Lines' 
plot_oi,t_fe26_la1,fe26_la1_apec+fe26_la2_apec
oplot, fe26_la_rs93.temperature,fe26_la_rs93.epsilon,linestyle=3
oplot,t_fe26_lb1,fe26_lb1_apec+fe26_lb2_apec,linestyle=1
oplot, fe26_lb_rs93.temperature,fe26_lb_rs93.epsilon,linestyle=3
legend,['LyA','LyB','RS93'],linestyle=[0,1,3],box=0,/top,/right
device,/close
