;
;  Set the following string to be the directory in which the APEC 
;  code is found
;
atomdb = getenv('ATOMDB')
;
;  Read the files
;
print,'Reading linelist apec_line.fits'
if (n_elements(line) eq 0) then $
  read_linelist,atomdb+'/apec_line.fits',line,t,n,l
print,'Linelist read.'
print,'Reading compressed continuum file apec_coco.fits'
if (n_elements(coco) eq 0) then $
  read_coco,atomdb+'/apec_coco.fits',coco,t,n,l
print,'Coco file read.'

print,'Making a spectrum of a 1.e7 K plasma.'
Ebin = make_range(0.1,10,5000)
spec = calc_spectrum(line,coco,Ebin,1.e7)
set_plot,'ps'
device,filename='spectrum.ps'
!xtitle = 'Energy (keV)'
!ytitle = 'Flux (ph cm^3/s/bin)'
plot_oo,Ebin,spec,psym=10
device,/close
set_plot,'X'
print,'Spectrum calculated; compare spectrum.ps to spectrum_cmp.ps.'

print,'Calculating ionization balance for Fe XVII at 1.e7'
ionbal = calc_ion_bal(26,17,1.e7,FILENAME=atomdb+'/APED/ionbal/MM98_ionbal.fits')
print,'Result is ',ionbal,'; should be 0.0324081'
print,'test_apecidl is complete.'
