FUNCTION calc_drrate, Z, rmJ, T, SILENT=silent, LEVEL=level, FILE=file

read_drline, Z, rmJ, data, header, found=found, FILE=file

if (n_elements(level) ne 0) then begin
    gp = where(data.lower_lev eq level,count)
    if (count eq 0) then begin
        if (n_elements(silent) ne 0) then print,'No DR data to level ',level
        return,0.*T
    endif
    data = data(gp)
endif

result = -1
RYDBERG=0.013605804
SAF_COEFF=3.30d-24               ; Need to work out definition of this.
gl = calc_statwt(Z,rmJ,1)        ; ground state weight of parent ion
kT = 8.617e-8*T

if (found eq 1) then begin
    totrate = 0.0
    Nlines = n_elements(data)
    for iLine=0,Nlines-1 do begin
        q_exc = data[iLine].satelint
        E_excite = data[iLine].e_excite
        rate = SAF_COEFF*((RYDBERG/kT)^1.5)*(q_exc/gl)*exp(-E_excite/kT)
        ;print,data[iLine].wavelen,data[iLine].satelint, rate
        totrate = totrate + rate
    endfor
    result = totrate
endif else begin
    if (n_elements(silent) ne 0) then print,'No such DR data'
    result = -2
endelse


return, result
end
