FUNCTION calc_kato_om, tr, E

X = E/tr.coeff_OM[0]
A = tr.Coeff_OM[1]
B = tr.Coeff_OM[2]
C = tr.Coeff_OM[3]
D = tr.Coeff_OM[4]
E = tr.Coeff_OM[5]
P = tr.Coeff_OM[6]
Q = tr.Coeff_OM[7]
X1= tr.Coeff_OM[8]
if (tr.Coeff_Type eq 41) then begin
    omega = A + B/X + C/(X*X) + D/(X*X*X) + E*alog(X)
endif else begin
    if (X > X1) then begin
        omega = A + B/X + C/(X*X) + D/(X*X*X) + E*alog(X)
    endif else begin
        omega = P*X + Q
    endelse
endelse

return, omega
end


FUNCTION calc_kato, tr, T

kB = 8.617e-8
y = tr.coeff_OM(0)/(kB*T)

if (tr.Coeff_Type eq 41) then begin
    expyTE1y = ExpInt(1,y)*exp(y)
    bp1 = where(expyTE1y eq 0 or (finite(expyTE1y) eq 0),c1)

    if (c1 gt 0) then expyTE1y(bp1) = ExpTExpInt(1,y(bp1))

;    gamma=y*((tr.Coeff_OM(1)/y +tr.Coeff_OM(3))+(tr.Coeff_OM(4)/2)*(1 - y) + $
;             exp(y)*E1y*(tr.Coeff_OM(2) - tr.Coeff_OM(3)*y + $
;                         tr.Coeff_OM(4)*y*y/2 + tr.Coeff_OM(5)/y))

    gamma=y*((tr.Coeff_OM(1)/y + tr.Coeff_OM(3))+(tr.Coeff_OM(4)/2)*(1 - y) + $
             expyTE1y*(tr.Coeff_OM(2) - tr.Coeff_OM(3)*y + $
                       tr.Coeff_OM(4)*y*y/2 + tr.Coeff_OM(5)/y))
endif else begin
    expX = exp((1.-tr.Coeff_OM(8))*y)
;    E1xy = ExpInt(1,tr.Coeff_OM(8)*y)
    expyTE1xy = expTExpInt(1,tr.Coeff_OM(8)*y)
    ry = 1. + 1./y

;    gamma_nr = y*expX*(tr.Coeff_OM(1)/y + $
;                       tr.Coeff_OM(3)/tr.Coeff_OM(8) + $
;                       (tr.Coeff_OM(4)/(2*tr.Coeff_OM(8)))*$
;                       (1./tr.Coeff_OM(8)- y)+ $
;                       (tr.Coeff_OM(5)/y)*alog(tr.Coeff_OM(8)) + $
;                       exp(y*tr.Coeff_OM(8))*E1xy*$
;                       (tr.Coeff_OM(2) - tr.Coeff_OM(3)*y + $
;                        tr.Coeff_OM(4)*y*y/2 + tr.Coeff_OM(5)/y))
    gamma_nr = y*expX*(tr.Coeff_OM(1)/y + $
                       tr.Coeff_OM(3)/tr.Coeff_OM(8) + $
                       (tr.Coeff_OM(4)/(2*tr.Coeff_OM(8)))*$
                       (1./tr.Coeff_OM(8)- y)+ $
                       (tr.Coeff_OM(5)/y)*alog(tr.Coeff_OM(8)) + $
                       expyTE1xy*(tr.Coeff_OM(2) - tr.Coeff_OM(3)*y + $
                                  tr.Coeff_OM(4)*y*y/2 + tr.Coeff_OM(5)/y))

    gamma_r  = tr.Coeff_OM(6)*ry*(1 - expX*(tr.Coeff_OM(8) + 1/y)/ry) + $
      tr.Coeff_OM(7)*(1-expX)
    gamma = gamma_nr + gamma_r
endelse 

return, gamma

end

