FUNCTION expTexpint2, n, x

MAXIT=1000
EULER=0.5772156649
FPMIN=1.0d-30
EPS=1.0d-7

result = 0.*x
nm1=n-1
bp = where(x lt 0.0,count)
bp2= where(x eq 0.0,count2)
if ((n lt 0) or (count gt 0)or(count2 gt 0 and (n eq 0 or n eq 1))) then begin
    print,'bad arguments in expint'
    stop
endif else begin
    if (n eq 0) then begin
        return,1./x 
    endif else begin
        gp1 = where(x eq 0.0,c1) 
        gp2 = where(x gt 1.0,c2)
        gp3 = where(x le 1.0,c3)
        if (c1 gt 0) then result(gp1) = exp(x(gp1))/nm1
        if (c2 gt 0) then begin
            for iX = 0,c2-1 do begin
                b=x(gp2(iX))+n           ;
                c=1.0/FPMIN     ;
                d=1.0/b         ;
                h=d             ;
                done = 0
                for i=1,MAXIT do begin
                    a = -i*(nm1+i) ;
                    b = b + 2.0 ;
                    d=1.0/(a*d+b) ;
                    c=b+a/c     ;
                    del=c*d     ;
                    h = h*del   ;
                    if (abs(del-1.0) lt EPS) then begin
                        result(gp2(iX)) = h
                        done = 1
                        i = MAXIT 
                    endif
                endfor
                if (done eq 0) then begin
                    print,result(gp2(iX)),h
                    result(gp2(iX)) = 0
                    print,'continued fraction failed in expint'
                endif
            endfor
        endif
        if (c3 gt 0) then result(gp3) = expint(n, x(gp3))*exp(x(gp3))
    endelse
endelse

end


FUNCTION expTexpint, n, x

if (n eq 0) then return,1./x
MAXIT=1000
EULER=0.5772156649
FPMIN=1.0d-30
EPS=1.0d-7

nm1=n-1
gp1 = where(x le 1.0,c1)
gp2 = where(x gt 1.0,c2)
result = 0.*x

if (c1 gt 0) then result(gp1) = exp(x(gp1))*expint(n,x(gp1))
if (c2 gt 0) then begin
    for iX=0,c2-1 do begin
        b=x(gp2(iX))+n                   ;
        c=1.0/FPMIN             ;
        d=1.0/b                 ;
        h=d             
        done = 0
        for i=1,MAXIT do begin
            a = -i*(nm1+i)      ;
            b = b + 2.0         ;
            d=1.0/(a*d+b)       ;
            c=b+a/c             ;
            del=c*d             ;
            h = h*del           ;
            if (abs(del-1.0) lt EPS) then begin
                result(gp2(iX)) = h
                done = 1
                i = MAXIT
            endif
        endfor  
        if (done eq 0) then begin
            result(gp2(iX)) = 0.0
            print,'Did not converge for x = ',x(gp2(iX))
        endif
    endfor
endif

return, result
end
