PRO read_pcoll, Z, rmJ, data, header, N_ext=N_ext, FOUND=found,$
                SILENT=silent, FILE=file, FORCE=force

common Pcoll_com, Z_Pcoll, rmJ_Pcoll, start_Pcoll, end_Pcoll, $
  data_Pcoll, header_Pcoll
;
;  Special file to load?
;
if ((n_elements(file) ne 0) or (n_elements(force) ne 0)) then begin
    if (n_elements(force) ne 0) then filename = get_filename(Z, rmJ, 3)
    if (n_elements(file) ne 0) then filename = file
    force = 1
endif else begin
;
; Check to see if this data has already been loaded
;
    count = 0
    if (n_elements(Z_Pcoll) ne 0) then $
      gp = where((Z eq Z_Pcoll)and(rmJ eq rmJ_Pcoll),count)
    if (count gt 1) then begin
        print,'Strange--multiple Z, rmJ matches!
        stop
    endif
; So load it and be done!
    if (count eq 1) then begin
        p1 = (start_Pcoll(gp))(0)
        p2 = (end_Pcoll(gp))(0)
        data = reform(data_Pcoll(p1:p2,gp))
        header = reform(header_Pcoll(*,gp))
        Found = 1
;    if (n_elements(silent) eq 0) then print,'Data loaded from memory'
        return
    endif
    filename = get_filename(Z,rmJ,5)
endelse

Found = -1
Ext = match_header(filename, Z, rmJ, 'COLL_STR', N_ext=N_ext)
if (Ext eq -1) then begin
    if (n_elements(silent) eq 0) then $
      print,'No matching extension for Z, rmJ = ',Z,rmJ,$
      ' found in ',filename,'.'
    return
endif

version = check_version(filename)

fxbopen, unit, filename, Ext, header
Nrow = fxpar(header, 'NAXIS2')
if (Nrow eq 0) then begin
    print,'No data in extension.'
    return
endif

fxbread, unit, Lower_Lev,  'Lower_Lev'
fxbread, unit, Upper_Lev,  'Upper_Lev'
fxbread, unit, Coeff_Type, 'Coeff_Type'
fxbread, unit, Min_Temp,   'Min_Temp'
fxbread, unit, Max_Temp,   'Max_Temp'
fxbread, unit, Temperature,'Temperature'
if (version eq 1.0) then fxbread, unit, Coeff_OM,   'Coeff_OM'
if (version eq 1.1) then fxbread, unit, Coeff_OM,   'EffCollStrPar'
if ((version ne 1.0) and (version ne 1.1)) then begin
    print,'Version ',version,' not recognized.'
    return
endif
fxbread, unit, Reference,  'Reference'

if (version eq 1.0) then data = replicate({Pcoll_S10},Nrow)
if (version eq 1.1) then data = replicate({Pcoll_S11},Nrow)
data.Lower_Lev = Lower_Lev
data.Upper_Lev = Upper_Lev
data.Coeff_Type = Coeff_Type
data.Min_Temp  = Min_Temp
data.Max_Temp  = Max_Temp
data.Temperature = Temperature
if (version eq 1.0) then data.Coeff_OM = Coeff_OM
if (version eq 1.1) then data.Coeff_OM = EffCollStrPar
data.Reference = Reference

fxbclose, unit

found = 1

if (force eq 0) then begin
    if ((n_elements(file) eq 0) and (found eq 1)) then begin 
; Add data to common blocks
        if (n_elements(Z_Pcoll) eq 0) then begin
            Z_Pcoll = Z
            rmJ_Pcoll = rmJ
            data_Pcoll = data
            header_Pcoll = header
            start_Pcoll = 0
            end_Pcoll = n_elements(data)-1
        endif else begin
            Z_Pcoll = [[Z_Pcoll],[Z]]
            rmJ_Pcoll = [[rmJ_Pcoll],[rmJ]]
            start_pos = max(end_Pcoll) + 1
            end_pos = start_pos + n_elements(data)-1
            start_Pcoll = [[start_Pcoll],[start_pos]]
            end_Pcoll = [[end_Pcoll],[end_pos]]
            data_Pcoll = [data_Pcoll,data]
            header_Pcoll = [header_Pcoll,header]
        endelse
    endif
endif

return
end
