;
;  Set the following string to be the directory in which the APEC 
;  code is found
;
apec_dir = getenv('APEC_DIR')
if (strcmp('',apec_dir) eq 1) then print,'System variable APEC_DIR not set!'
if (strcmp('',apec_dir) eq 1) then print,'Set it to the APEC directory root.'
if (strcmp('',apec_dir) eq 1) then stop
;
;
;
strings = '01234567890123456789012345678901234567890123456789'
tmp1 = {IonBal_S, Temperature: 1.0, density:1.0, Z:intarr(30), $
        indx:intarr(30), X:fltarr(500), filename:strings}

tmp2 = {Emission_S, T:1.0, N:1.0, L_Tot:1.0, L_Line:1.0, $
        L_Brems:1.0, L_RRC:1.0, L_TwoPh:1.0}

tmp3 = {Coco_S, Temperature:1.0, Density:1.0, Z: 1, rmJ: 1, N_cont: 1, $
        E_Cont:fltarr(250),  Continuum:fltarr(250), Cont_Err:fltarr(250), $
        N_pseudo:1, E_Pseudo:fltarr(2500), Pseudo:fltarr(2500), $
        Pseudo_Err:fltarr(2500)}

apec_idl_dir = apec_dir+'/apec_v10_idl'
if (strpos(!path,apec_idl_dir) eq -1) then !path=!path+':'+apec_idl_dir

delvar,tmp1,tmp2,tmp3,strings,apec_idl_dir

.run make_range
.run read_array

.run interp_header
.run match_header
.run read_linelist
.run read_continuum
.run read_coco

.run roman_element

.run expand_E_grid
.run calc_spectrum

.run extract_line
.run select_line
.run extract_strong

delvar,apec_dir
