PRO read_drline, Z, rmJ, data, header, N_ext=N_ext, FOUND=found,$
                 SILENT=silent, FILE=file

common DRline_com, Z_DRline, rmJ_DRline, start_DRline, end_DRline, $
  data_DRline, header_DRline
;
;  Special file to load?
;
if (n_elements(file) ne 0) then begin
    filename = file
endif else begin
;
; First, check to see if this data has already been loaded
;
    count = 0
    if (n_elements(Z_DRline) ne 0) then $
      gp = where((Z eq Z_DRline)and(rmJ eq rmJ_DRline),count)
    if (count gt 1) then begin
        print,'Strange--multiple Z, rmJ matches!
        stop
    endif
; So load it and be done!
    if (count eq 1) then begin
        p1 = (start_DRline(gp))(0)
        p2 = (end_DRline(gp))(0)
        data = reform(data_DRline(p1:p2,gp))
        header = reform(header_DRline(*,gp))
        Found = 1
;    if (n_elements(silent) eq 0) then print,'Data loaded from memory'
        return
    endif else begin
        filename = get_filename(Z, rmJ, 6)
    endelse
endelse

Found = -1
Ext = match_header(filename, Z, rmJ, 'DR_LINES', N_ext=N_ext)
if (Ext eq -1) then begin
    if (n_elements(silent) eq 0) then $
      print,'No matching extension for Z, rmJ = ',$
      Z,rmJ,' found in ',filename,'.'
    return
endif

fxbopen, unit, filename, Ext, header
Nrow = fxpar(header, 'NAXIS2')
if (Nrow eq 0) then begin
    print,'No data in extension.'
    return
endif

fxbread, unit, Lower_Lev, 'Lower_Lev'
fxbread, unit, Upper_Lev, 'Upper_Lev'
fxbread, unit, Wavelen,   'Wavelen'
fxbread, unit, Wave_Obs,  'Wave_Obs'
fxbread, unit, Wave_Err,  'Wave_Err'
fxbread, unit, DR_Type,   'DR_Type'
fxbread, unit, E_Excite,  'E_Excite'
fxbread, unit, Eexc_Err,  'Eexc_Err'
fxbread, unit, SatelInt,  'SatelInt'
fxbread, unit, SatIntErr, 'SatIntErr'
fxbread, unit, Params,    'Params'
fxbread, unit, Reference, 'Reference'

data = replicate({DRLine_S},Nrow)
data.Lower_Lev = Lower_Lev
data.Upper_Lev = Upper_Lev
data.Wavelen   = Wavelen
data.Wave_Obs  = Wave_Obs
data.Wave_Err  = Wave_Err
data.DR_Type   = DR_Type
data.E_Excite  = E_Excite
data.Eexc_Err  = Eexc_Err
data.SatelInt  = SatelInt
data.SatIntErr = SatIntErr
data.Params    = Params
data.Reference = Reference

fxbclose, unit

Found = 1

return
end
