PRO read_eline, Z, rmJ, data, header, N_ext=N_ext, FOUND=Found,$
                SILENT=silent, FILE=file

common Eline_com, Z_Eline, rmJ_Eline, start_Eline, end_Eline, $
  data_Eline, header_Eline
;
;  Special file to load?
;
if (n_elements(file) ne 0) then begin
    filename = file
endif else begin
;
; First, check to see if this data has already been loaded
;
    count = 0
    if (n_elements(Z_Eline) ne 0) then $
      gp = where((Z eq Z_Eline)and(rmJ eq rmJ_Eline),count)
    if (count gt 1) then begin
        print,'Strange--multiple Z, rmJ matches!
        stop
    endif
; So load it and be done!
    if (count eq 1) then begin
        p1 = (start_Eline(gp))(0)
        p2 = (end_Eline(gp))(0)
        data = reform(data_Eline(p1:p2,gp))
        header = reform(header_Eline(*,gp))
        Found = 1
;    if (n_elements(silent) eq 0) then print,'Data loaded from memory'
        return
    endif else begin
        filename = get_filename(Z, rmJ, 3)
    endelse
endelse

Found = -1
Ext = match_header(filename, Z, rmJ, 'EM_LINES', N_ext=N_ext)
if (Ext eq -1) then begin
    if (n_elements(silent) eq 0) then $
      print,'No matching extension for Z, rmJ = ',Z,rmJ,$
      ' found in ',filename,'.'
    return
endif

fxbopen, unit, filename, Ext, header
Nrow = fxpar(header, 'NAXIS2')
if (Nrow eq 0) then begin
    print,'No data in extension.'
    return
endif

fxbread, unit, Lower_Lev, 'Lower_Lev'
fxbread, unit, Upper_Lev, 'Upper_Lev'
fxbread, unit, Wavelen,   'Wavelen'
fxbread, unit, Wave_Obs,  'Wave_Obs'
fxbread, unit, Wave_Err,  'Wave_Err'
fxbread, unit, Einstein_A,'Einstein_A'
fxbread, unit, Ein_A_Err, 'Ein_A_Err'
fxbread, unit, Reference, 'Reference'

data = replicate({ELine_S},Nrow)
data.Lower_Lev = Lower_Lev
data.Upper_Lev = Upper_Lev
data.Wavelen   = Wavelen
data.Wave_Obs  = Wave_Obs
data.Wave_Err  = Wave_Err
data.Einstein_A= Einstein_A
data.Ein_A_Err = Ein_A_Err
data.Reference = Reference

fxbclose, unit

found = 1

if (found eq 1) then begin  ; Add data to common blocks
    if (n_elements(Z_Eline) eq 0) then begin
        Z_Eline = Z
        rmJ_Eline = rmJ
        data_Eline = data
        header_Eline = header
        start_Eline = 0
        end_Eline = n_elements(data)-1
    endif else begin
        Z_Eline = [[Z_Eline],[Z]]
        rmJ_Eline = [[rmJ_Eline],[rmJ]]
        start_pos = max(end_Eline) + 1
        end_pos = start_pos + n_elements(data)-1
        start_Eline = [[start_Eline],[start_pos]]
        end_Eline = [[end_Eline],[end_pos]]
        data_Eline = [data_Eline,data]
        header_Eline = [header_Eline,header]
    endelse
endif

return
end
