PRO read_ioniz_gr, filename, Z, rmJ, data, header, N_ext=N_ext, FOUND=Found,$
                   SILENT=silent

Found = -1
Ext = match_header(filename, Z, rmJ, 'IONIZ_GR', N_ext=N_ext)
if (Ext eq -1) then begin
    if (n_elements(silent) eq 0) then $
      print,'No matching extension for Z, rmJ = ',Z,rmJ,$
      ' found in ',filename,'.'
    return
endif

fxbopen, unit, filename, Ext, header
Nrow = fxpar(header, 'NAXIS2')
if (Nrow eq 0) then begin
    print,'No data in extension.'
    return
endif

fxbread, unit, N_E_SH,   'N_E_SH'
fxbread, unit, Sh_Label, 'Sh_Label'
fxbread, unit, N_q,      'N_q'
fxbread, unit, L_q,      'L_q'
fxbread, unit, Energy,   'Energy'
fxbread, unit, E_Error,  'E_Error
fxbread, unit, CollType, 'CollType'
fxbread, unit, CollCoef, 'CollCoef'
fxbread, unit, PhotType, 'PhotType'
fxbread, unit, PhotCoef, 'PhotCoef'
fxbread, unit, RR_Type,  'RR_Type'
fxbread, unit, RR_Coef,  'RR_Coef'
fxbread, unit, DR_Type,  'DR_Type'
fxbread, unit, DR_Coef,  'DR_Coef'
fxbread, unit, Reference,'Reference'

data = replicate({Ioniz_gr_S},Nrow)
data.N_E_SH = N_E_SH
data.Sh_Label = Sh_Label
data.N_q = N_q
data.L_q = L_q
data.Energy = Energy
data.E_Error = E_Error
data.CollType = CollType
data.CollCoef = CollCoef
data.PhotType = PhotType
data.PhotCoef = PhotCoef
data.RR_Type = RR_Type
data.RR_Coef = RR_Coef
data.DR_Type = DR_Type
data.DR_Coef = DR_Coef
data.Reference = Reference

fxbclose, unit

Found = 1

return
end
