PRO zscale, Z, outfile, TMIN=Tmin, TMAX=Tmax
;
; Need to approximate (at least) Energy levels, wavelengths, and collision
; strengths.  
!p.multi=[0,10,10]
common sgc_data, sdat, pdat, edat
if (n_elements(Sdat) eq 0) then read_sgc_s,'SGC_29_Swave.idl',sdat
if (n_elements(Pdat) eq 0) then read_sgc_p,'SGC_29_P+wave.idl',pdat
if (n_elements(edat) eq 0) then read_Elevels,'Elev_gs.dat','Elev_nl.dat',1,edat
;
read_array,'needed_tr.dat',a
ll = fix(reform(a(0,*)))
lu = fix(reform(a(1,*)))
Ntr = n_elements(lu)
Zarr = [6,8,10,12,14,16,18,20]
N_Z = n_elements(Zarr)
N_T = 20
if (n_elements(Tmin) eq 0) then Tmin = 1.e5
if (n_elements(Tmax) eq 0) then Tmax = 1.e9
T = make_range(Tmin,Tmax,N_T,/log)
T = T/(Z*Z*Z)
;T = [200,400,600,900,1350,2000,3000,4500,6700,1e4,2.e4,3.e4]
;N_T = n_elements(T)
;
;
;
zero = 0
gamma = fltarr(Ntr,N_T)
get_lun,lun
openw,lun,outfile
printf,lun,zero,zero, T*Z*Z*Z,FORMAT='(i3,i3,20E12.3)'
gvec = fltarr(N_Z,N_T)
Tsc  = fltarr(N_Z,N_T)
for iTr = 0,Ntr-1 do begin
    for iZ=0,N_Z-1 do begin
        gvec(iZ,*) = gamma_sgc(Zarr(iZ),ll(iTr),lu(iTr),T*(Zarr(iZ)^3))*$
          Zarr(iZ)*Zarr(iZ)
    endfor
    for iT=0,N_T-1 do begin
        x = Zarr
        y = alog10(reform(gvec(*,iT)))
        gp = where(finite(y) eq 1,count)
        if (count eq 0) then begin
            print,'No good points',ll(iTr),lu(iTr),T(iT)*Z*Z*Z
            gamma(iTr,iT) = 0.0
        endif else begin
            x = x(gp)
            y = y(gp)
            plot,x,y
            c = poly_fit(x,y,3)
            gamma(iTr,iT) = (10^poly(Z,c))/(Z*Z)
        endelse
    endfor
    printf,lun,ll(iTr),lu(iTr),reform(gamma(iTr,*)),FORMAT='(i3,i3,20E12.3)'
endfor

free_lun,lun

return
end
