%
%
%
% Ronnie Hoogerwerf, SAO, 06/04/2002
%
implements("LF");
variable runonce;
if (__is_initialized(&LF->runonce) == 0) {

   static variable filename = "$ATOMDB/apec_v1.3.0_linelist.fits";
   static variable filename_101 = "$ATOMDB/apec_v1.2.0_linelist.fits";
   static variable ionbalfile = "$ATOMDB/APED/ionbal/MM98_ionbal.fits";
   static variable data = NULL;
   static variable data_short = NULL;
   static variable ionbal = NULL;
   static variable ionbal_index = NULL;
   static variable Tmin = 10000.0, Tmax = 790000000.0;
   static variable Lmin = NULL, Lmax = NULL;
   static variable epsmin = NULL, epsmax = NULL;
   static variable mingap = 0.1;
   static variable n = 6, iLambda = 0, iEpeak = 1, iTpeak = 2, 
                   iTmin = 3, iTmax = 4, iIon = 5;
   variable runonce = 1;
}

() = evalfile("LF-SL-uses.sl");      % header facility
() = evalfile("LF-expand_env.sl");
() = evalfile("LF-SL-include.sl");
() = evalfile("LF-MATH-include.sl");

if (NULL == getenv("ATOMDB")) {
   message("The environmental variable \"ATOMDB\" has not been set.");
   message("The \"line_free_region\" command could not be loaded.");
   message("Please define \"ATOMDB\".");
} else {

   () = evalfile("LF-ionbal.sl");
   () = evalfile("LF-read-data.sl");
   () = evalfile("LF-linefree.sl");
   () = evalfile("LF-plotlinefree.sl");
   () = evalfile("LF-noticelinefree.sl");

}
message("==> Importing ATOMDB to calculate line free regions...");
() = LF->read_ionbal();
() = LF->read_data(filename,filename_101);
message("    Done.");
%
%
%
%
