      subroutine calc_evolve(Telec, Tion, Tend, Tsw, dT, CoolingType,
     $     MaxTime, MaxFluenc, UseDust, Pressure, Wisconsin,
     $     numlines, atom_index, ion_index)

      implicit none
      include 'jr_common.inc'

      real kB
      integer MAXLINES
      parameter(kB=1.38062e-16,MAXLINES=2000)

      integer it, no, nz, nz1, j
      real Telec, Tion, Tend, Tsw, dT, T, dTemp
      real dene, dtime, time, chi, n0, pressure
      real coolcoeff, dustcool, MaxTime, totcool
      real fluenc, dfluenc, dfl1, dfl2, MaxFluenc
      real Hneut,Hion
      integer usedust, CoolingType, Wisconsin
      logical isobaric

      integer numlines, atom_index(MAXLINES), ion_index(MAXLINES)

      integer icopy
      real cion, calc_rhy
      external icopy, calc_rhy

c      real P,Rmin,Rmax,Frac,dustrho,abund(NUM2),Porosity
c      common/dust/P(2),Rmin(2),Rmax(2),Frac(3,NUM2),dustrho(3),Porosity
c      real dustcl(2)
c      common/dustparms/dustcl
c      F(1) = 0.0
c      F(2) = 0.0
c      totdustcool(1) = 0.0
c      totdustcool(2) = 0.0

      isobaric = .false.
      dustcool=0.
      chi = 2.090909
      if (pressure .gt. 0) then 
         n0 = pressure/(chi*Telec)
      else
         n0 = 0.1
      end if
      dene = (chi-1)*n0

      if ((CoolingType.eq.1).or.
     $     ((CoolingType.eq.3).and.(T.ge.Tsw))) isobaric = .true.
         
      if (isobaric.and.(pressure .lt.0.)) then
         write(*,*) 'calc_evolve: Bad input conditions.'
         stop
      end if
c
c Set up the equilibrium ion concentrations at temp T0
c     
      Rhy = calc_rhy(Hneut,Hion,Tion)
      call feline(Tion,dene,NUM,0,0,0,0,0,1)
c
      fluenc = 0.
      dfluenc = 100.
      dtime = dfluenc/dene
      time = 0
      it = 0 
      T = Telec

      if (CoolingType.eq.0) CoolCoeff = 1.E-10
      if (CoolingType.eq.1) CoolCoeff = 2./5.5
      if (CoolingType.eq.2) CoolCoeff = 2./3.3
      if ((CoolingType.eq.3).and.(T.ge.Tsw))
     $     CoolCoeff = 2./5.5        ! Starts out isobaric
      if ((CoolingType.eq.3).and.(T.lt.Tsw))
     $     CoolCoeff = 1.e-10        ! Then isothermal

c
c Start loop.
c
 100  it = it + 1
c
c Evolve the ion concentrations, and get cooling rate.
c
      Rhy = calc_rhy(Hneut,Hion,T)
      do no=1,num
         nz = icopy(no)
         call nquil(T, nz, dene, 1, 0,0,1)
         call cycle(nz, dene, dtime)
         nz1 = nz + 1
         do j=1,nz1
            cnc(no,j) = conce(j)
         end do
      end do

      call feline(T,dene,NUM,0,0,1,0,0,1)
c
c If using dust, sputter the dust and get dust cooling.
c
      if (usedust.eq.1) then 
         write(*,*) 'Dust not ready yet.'
         stop
c         call sputter(abund,T,rho,chi,dtime,F,X,dustms,dustcool)
c         dustmass = dustms(1) + dustms(2)
c         totdustcool(1) = totdustcool(1) + dtime*dene*dustcl(1)
c         totdustcool(2) = totdustcool(2) + dtime*dene*dustcl(2)
      end if
c
c Calculate total cooling from both dust and gas.
c
      totcool = pcool + dustcool
c
c Now, a bit of tricky work to resolve the ion flash. RKS 2/4/93
c 
      if (fluenc.eq.0) then
         dfluenc=100.
      else
         dfl1 = 10.**(0.9*log10(fluenc))
         dfl2 = dT*T/(CoolCoeff*totcool*1.e-23/(chi*kB))
         if (CoolingType.eq.0) dfl2 = dfl1
         dfluenc  = min(dfl2,dfl1)
      end if
c
c End of ion flash business.  Calculate updated variable values
c     
      fluenc = fluenc + dfluenc 

      dtime = dfluenc/dene
      time = time + dtime 

      if ((CoolingType.eq.1).or.
     $   ((CoolingType.eq.3).and.(T.ge.Tsw)))
     $     dene = (chi-1)*pressure/(chi*T)

      if ((CoolingType.eq.3).and.(T.le.Tsw))
     $     CoolCoeff = 1.e-10

      dTemp = -CoolCoeff*totcool*1.e-23*dfluenc/(chi*kB)
      if (T .gt. Tend) T = T + dTemp

      call output(fluenc, time, T, dene, totcool, wisconsin,
     $     numlines, atom_index, ion_index)
c
c Are we done?
c      
      if ((MaxTime.gt.0.).and.(time/secyr.ge.MaxTime)) go to 200
      if ((MaxTime.le.0.).and.(T.lt.Tend)) go to 200
      if ((MaxFluenc.gt.0).and.(fluenc.ge.MaxFluenc)) go to 200
      go to 100

 200  continue

      return
      end
