#ifndef _CONSTANTS_H_
#define _CONSTANTS_H_

static const double 
  mn = 2.11938e-24,    /* grams per nucleon, aka mu*Mproton */
  kB = 1.38062e-16,    /* Boltzmann's constant erg/K */
  pc = 3.085678e18,    /* 3.086E18, cm/pc */
  pi = 3.141592654,    /* Think about circles */
  secyr = 3.15576E7,      /* seconds per year */
  alpha = 1.3E-19,     /* Kahn approximation constant */
  beta = 6.E-7,        /* Thermal conductivity constant */
  brem = 8.955E-27,    /* Thermal bremsstralung constant */
  Hmass = 1.00,        /* Mass of H atom in H atom units */
  mu = 1.26707,        /* From Anders & Grevesse, (1+4*abhe)/(1+abhe) */
  Msolar = 1.989E33,   /* Mass of sun, in grams */
  evtoerg = 1.602E-12, /* Conversion from eV's to ergs. */
  Hion = 13.598,       /* Ionization energy of H I, in eV's */
  Heion = 24.587;      /* Ionization energy of He I, in eV's */

#endif /* _CONSTANTS_H_ */
