      subroutine find_lines(min_line_sep,atom_indexfull, ion_indexfull,
     $     line_name, totnumlines, emis_lines, atom_lines, ion_lines,
     $     numlines, atom_index, ion_index, line_index)

      implicit none

      include 'jr_common.inc'
      
      integer MAXLINES
      parameter(MAXLINES=2000)

      integer atom_indexfull(MAXLINES), ion_indexfull(MAXLINES)
      integer line_index(MAXLINES)
      character*10 line_name(MAXLINES)
      integer totnumlines, numlines
      real emis_lines(MAXLINES), min_line_sep
      integer atom_lines(MAXLINES), ion_lines(MAXLINES)
      integer atom_index(MAXLINES), ion_index(MAXLINES)
      character*2 jr_atom(NUM)
      integer i,j
      real mindist, dist
      logical matched
      data jr_atom/'He','C ','N ','O ','Ne','Mg','Si','S ','Ar','Ca',
     $     'Fe','Ni'/

      do i=1,numlines
         matched = .FALSE.
         mindist = min_line_sep    ! minimum distance is 1 angstrom
         do j=1,totnumlines
            dist = wj(atom_indexfull(j),ion_indexfull(j))-emis_lines(i)
            if (abs(dist) .le. mindist) then
c               write(*,*) atom_lines(i),ion_lines(i),atom_index(i)
               if ((atom_lines(i)+1.eq.atom_indexfull(j)).or.
     $              (atom_lines(i).eq.-1)) then
c                  if ((ion_lines(i)+1.eq.ion_index(i)).or.
c     $                 (ion_lines(i).eq.-1)) then
c                  end if
                  atom_index(i) = atom_indexfull(j)
                  ion_index(i)  = ion_indexfull(j)
                  line_index(i) = j
                  mindist = dist
                  matched = .TRUE.
               end if
            end if
         end do
         if (.not. matched) then
            write(*,*) 'find_lines: No match found for ',emis_lines(i)
            write(*,*) 'find_lines: within 1 Angstrom'
            write(*,*) 'find_lines: Aborting.'
            stop
         else
            write(*,*) 'find_lines: Match found for ',emis_lines(i)
            write(*,*) 'find_lines: for atom, ion, line_index: ',
     $           atom_index(i), ion_index(i), line_index(i)
            write(*,*) 'Line name : ', line_name(line_index(i)),' (',
     $           jr_atom(atom_index(i)),')'
         end if
      end do
      
      return
      end
