C  CALLS XSPCT FOR VARIOUS PARAMETERS:
c  Dec 17, 1991 : modify GAUNT5 to improve transition 1 of Li-like ions (JCR)
c  Sep 21, 1993 : add option to choose the solar photospheric and coronal 
c  abundances from Anders and Grevesse (1989, Geochimica et Cosmochimica Acta, 
c  53, 197) as well as the cosmic abundances from Allen 1973 (SAD)
C  Note that the default abundances are Allen 1973 cosmic values. 
      character*1 IREP,IAB, IABSEL

      COMMON/HLN/EXT(11),HALF,HALFC,ALFLY,ALFLYC,HBET,HBETC,TWOP
	COMMON/BLN/BLN(1000),BLNMIN,BLNSYZ,NBLN
      common/PARAMS/NJ(12),ABUNJ(12),ABUND,BINMIN,BINSYZ,NBIN
	COMMON/RESULT/CONCE(30),GNDREC(30),POWER(220),RHY,HENEUT,HEPLUS,
     1  DNE,PCOOL,POU,POT,RE,TU,PM(4)
      COMMON/PT/RF(500),TAU(150),TAUHE(150),TPLUS(150)
      COMMON/CONTIN/BRMEV(1000),RECEV(1000),TUFEV(1000)
      common/com/cnc(12,30),PTOT(12,220),abin(1000),bin(1000)
      DIMENSION abcor(12), abphot(12)    
      DATA ABUNJ/10.93,8.52,7.96,8.82,7.92,7.42,7.52,7.2,6.9,6.3,
     1  7.6,6.3/, ABCOR/10.14,7.90,7.40,8.30,7.46,7.59,7.55,6.93,
     2  5.89,6.46,7.65,6.22/, ABPHOT/10.99,8.56,8.05,8.93,8.09,
     3  7.58,7.55,7.21,6.56,6.36,7.67,6.25/  
      DATA RF/500*1.0/

	open(unit=1,file='file1.dat')
	open(unit=2,file='atomic.dat')
	open(unit=3,file='file2.dat')
	open(unit=7,file='answers.dat')

      print *, 'HELLO.  THIS PROGRAM COMPUTES EQUILIBRIUM OPTICALLY THIN
     1 X-RAY AND EUV EMISSION SPECTRA.  ENTER NBIN, BINMIN, BINSYZ.'
      READ *,NBIN,BINMIN,BINSYZ
      print *,' WAVELENGTH BINS MAYBE? NBLN,BLNMIN,BLNSYZ'
      READ *,NBLN,BLNMIN,BLNSYZ
      print *, 'NUM, IPRINT, JPRINT, IPHOT, IDENS, ICX?'
      READ *,NUM,IPRINT,JPRINT,IPHOT,IDENS,ICX

      CALL ATREAD(NUM)

      IF (IPHOT .NE. 0) THEN
        print *, 'RF1?'
        READ *,RF1
        CALL RADRD(1)
        DO 10 N=1,NBIN
   10   ABIN(N)=RF1*ABIN(N)
      END IF

   20 continue

      print *, 'DO YOU WISH TO MODIFY ABUNDANCES?'
      READ (5,1) IAB
    1 FORMAT (A1)
      IF (IAB .NE. 'Y' .AND. IAB .NE. 'y') GO TO 30
   25 CONTINUE
      print *, 'WANT CORONAL(C), PHOTOSPHERIC(P), OR 1 by 1(1)?'
      READ (5,1) IABSEL
      IF (IABSEL.EQ.'C'.OR.IABSEL.EQ.'c') go to 251
      IF (IABSEL.EQ.'P'.OR.IABSEL.EQ.'p') go to 253      
      print *, 'NO, ABUND?'
      READ (5,*) NO,ABUND
C
      ABUNJ(NO) = ABUND
C
      print *, ' ANOTHER ABUNDANCE MODIFICATION?'
      READ (5,1) IAB
      IF (IAB .EQ. 'Y' .OR. IAB .EQ. 'y') GO TO 25
      GO TO 30
 251  CONTINUE
      DO 252 I=1,12
 252  ABUNJ(I)= ABCOR(I)
      GO TO 30
 253  CONTINUE
      DO 254 I=1,12
 254  ABUNJ(I)= ABPHOT(I)       
   30 CONTINUE
      print *, 'LOG T?'
      READ (5,*) T
      T = 10. ** T
      print *,' LOG DENE?'
      READ (5,*) DENE
      DENE = 10. ** DENE
C COMPUTE RATIO OF IONIZED TO NEUTRAL HYDROGEN
	CIONH = CION(1,1,13.6,T)
      if (iphot .ne. 0) cionh = cionh + phot(1,1,13.6,t,dene)/dene
	BE = 157890. / T
	CREC = 2.06E-11*(.4288+.5*ALOG(BE)+.469*BE**(-.33333))/SQRT(T)
	RHY = CIONH / CREC

      write (7,*) ' rhy = ', rhy
C
C

      CALL FELINE(T,DENE,NUM,IPRINT,JPRINT,0,IPHOT,IDENS,ICX)

c  put hydrogen emission into bins

c     st = sqrt(t)
c     call hline(rhy,0.,t,st,be,0)
c     critn = 100.*sqrt(t)
c     p2ph = ext(11)*critn/(critn+dene)
c     ext(9) = ext(9) + ext(11)*(1.-critn/(critn+dene))
c     imax = (12399./1215.6 - binmin)/binsyz
c     imax= min0(imax,nbin)
c     if (imax .le. 1) go to 76
c     DO 75 ik= 1,imax
c     r = (binmin+binsyz*(ik-.5)) * 1215.6/12399.
c     tufev(ik) = 12.*p2ph*r*r*(1.-r)*1215.6*binsyz/12399.
c     print *,ik,tufev(ik)
c  75 bin(ik) = bin(ik) + tufev(ik)
c  76 continue

c     ilmin = (1215.6 - blnmin) / blnsyz + 1
c       DO 85 ibln = ilmin,nbln
c       wbln = (ibln - 0.5)*blnsyz + blnmin 
c       ephot = 12399. / wbln 
c       ibn = (ephot-binmin) / binsyz + 1
c       de = ephot - 12399. / (wbln + blnsyz)
c       if (ibn .ge. 1 .and. ibn .le. nbin) bln(ibln) = bln(ibln) +
c    1  tufev(ibn) * de / binsyz
c  85   continue


      ibn = (10.2-binmin) / binsyz + 1
      if (ibn .ge. 1 .and. ibn .le. nbin) bin(ibn) = bin(ibn) + ext(6) 
     1   + ext(9)
      if (blnsyz .gt. 0) ibl = (1215.6-blnmin) / blnsyz + 1
      if (ibl .ge. 1 .and. ibl .le. nbln) bln(ibl) = bln(ibl) + ext(6) 
     1  + ext(9)
 
	IF (NBIN .EQ. 0) GO TO 70
      WRITE (1,50) T,BINMIN,BINSYZ,ABUNJ
   50 FORMAT (' TEMPERATURE=',E10.2,' BINMIN,
     1  BINSYZ=',2F7.1,' ABUNJ',12F6.2)
      WRITE (1,60) (BIN(K),K=1,NBIN)
   60 FORMAT (10E12.3)

	IF (NBLN .EQ. 0) GO TO 70
	WRITE (3,50) T,BLNMIN,BLNSYZ,ABUNJ
	WRITE (3,60) (BLN(K),K=1,NBLN)
   70 CONTINUE
      print *, ' ANOTHER SET OF PARAMETERS?'
      READ (5,1) IREP
      IF (IREP .EQ. 'Y' .OR. IREP .EQ. 'y') GO TO 20
      stop
      end
