#include <math.h>
#include <stdlib.h>
#include <strings.h>
#include <stdio.h>
#include "descript.h"
#include "messages.h"
#include "cool.h"
#define NUMATOMS 12
#define NUMIONS 29

void parse_atom(char *name, int *atom, int *ion) {

  char atomstr[MAXSTRLEN],ionstr[MAXSTRLEN];
  static char *atomname[] = {"He", "C", "N", "O", "Ne", "Mg", "Si",
			     "S", "Ar", "Ca", "Fe", "Ni"};
  static char *ionname[] = {"I","II","III","IV","V","VI","VII","VIII",
			    "IX","X","XI","XII","XIII","XIV","XV","XVI",
			    "XVII","XVIII","XIX","XX","XXI","XXII","XXIII",
			    "XXIV","XXV","XXVI","XXVII","XXVIII","XXIX"};
  int i;

  *atom = -1;
  *ion  = -1;
  *atomstr = '\0';
  *ionstr  = '\0';

  sscanf(name,"%s %s",atomstr, ionstr);
  /*  printf("%s %s\n",atomstr, ionstr); */
  for (i=0;i<NUMATOMS;i++) {
    if (strlen(atomstr) == strlen(atomname[i])) {
      if (strncmp(atomstr,atomname[i],strlen(atomstr))==0) {
	*atom = i;
      }
    }
  }
  for (i=0;i<NUMIONS;i++) {
    if (strlen(ionstr) == strlen(ionname[i])) {
      if (strncmp(ionstr,ionname[i],strlen(ionstr))==0) *ion = i;
    }
  }
}
