      SUBROUTINE ReadDustInfo(dustpor, abund)
C
C     4/27/92 Randall Smith (RKS)
C     Reads in the initial conditions for dust particles from an ASCII
C     file.  
C
c     11/9/94 RKS
C     Added porosity; reads correct line for given silicate porosity.
c
c
      implicit NONE

      include 'jr_common.inc'
      include 'datafiles.inc'
      
      real dustpor
      real P,Rmin,Rmax,Frac,dustrho,abund(num),Porosity
      real dustsz(2,4),carbon_por
      integer j,i

      common/dust/P(2),Rmin(2),Rmax(2),Frac(3,num),dustrho(3),Porosity

      OPEN(UNIT=15,File=dust_info, STATUS='OLD')

      read(15,*) dustsz(1,1),dustsz(1,2),dustsz(1,3),dustsz(1,4)
      read(15,*) dustsz(2,1),dustsz(2,2),dustsz(2,3),dustsz(2,4)
      if (dustpor .eq. dustsz(1,1)) then
         P(1) = dustsz(1,2)
         Rmin(1) = dustsz(1,3)
         Rmax(1) = dustsz(1,4)
      else if (dustpor .eq. dustsz(2,1)) then
         P(1) = dustsz(2,2)
         Rmin(1) = dustsz(2,3)
         Rmax(1) = dustsz(2,4)
      else
         write(*,*) 'ReadDust: unavailable porosity, value = ',
     $        dustpor
         stop
      end if

      READ(15,*) carbon_por,P(2),Rmin(2),Rmax(2)
      READ(15,*) (dustrho(j),j=1,3)
      do 6 j=1,2
	Rmin(j) = Rmin(j)*1e4
	Rmax(j) = Rmax(j)*1e4
6     continue
      READ(15,*) abundinit(1),Frac(1,1),Frac(2,1),Frac(3,1)
      do 10 j=1,num
         READ(15,*) abundinit(j),Frac(1,j),Frac(2,j),Frac(3,j)
c............correct for logarithmic form in input file.  4/29 rje
	do 8 i=1,3
	  Frac(i,j) = 10.**(Frac(i,j)-12.)
 8	continue
        abund(j) = abundinit(j)
        abundinit(j) = 10.**(abundinit(j)-12.)
 10   continue

      CLOSE(UNIT=15)

      RETURN
      END






