import("slrs93");
Nbin = 1000;
Emin = 500.;
Esyz = 0.1;

slrs93_setbin(Nbin, Emin, Esyz);
Evec = Emin + [0:Nbin-1:1]*Esyz;
Evec = Evec/1.e3;

Tlow = 3.e5;
Thi  = 3.e6;
dene = 1.0;
slrs93_equil(Tlow, dene);
equilspec = slrs93_getresult();
equilflux = 5.e6*equilspec.spec;
dtime = 1.0;
slrs93_nonequil(Thi, dene, dtime);
ionizspec = slrs93_getresult();
ionizflux = ionizspec.spec;
  
clear;
() = curve(Evec, equilflux);
() = curve(Evec+0.0001, ionizflux);
limit x 0.56 0.58
c 1 symbol none;
c 2 symbol none;
c 1 simple;
c 2 simple;
c 1 blue;
c 2 red;
c 1 histo;
c 2 histo;
limit y 1.e-5 1
log y;
xlabel "Energy (keV)";
ylabel "Flux (1e-23 ergs cm^3 / s / bin)";
redraw;


