/** \file TestDataImport.cxx
    \brief Implementation of DataImport unit test.
    \author James Peachey

    The Profit software package was developed by Dr. Randall Smith and
    Mr. James Peachey at the High Energy Astrophysics Science Archive
    Research Center (HEASARC) at the Goddard Space Flight Center (GSFC)
    of the National Aeronautics and Space Administration (NASA).
*/
#include "profit/DataImport.h"
#include "profit/Gui.h"
#include "profit/UnitTestGui.h"

namespace profit {

  void UnitTestGui::testDataImport() {
    std::string method = "testDataImport()";

    info(method) << "Creating data import dialog box for test." << std::endl;
    DataImport * import = new DataImport(Gui::instance());
    info(method) << std::endl;

    info(method) << "Running data import dialog box in test mode." << std::endl;
    import->runInTestMode();
    delete import;
    info(method) << std::endl;
  }

}
