/** \file roman_element.h
    \brief Declarations for textual formatting utilities adapted from APEC.
    \author Randall Smith, James Peachey

    The Profit software package was developed by Dr. Randall Smith and
    Mr. James Peachey at the High Energy Astrophysics Science Archive
    Research Center (HEASARC) at the Goddard Space Flight Center (GSFC)
    of the National Aeronautics and Space Administration (NASA).
*/
const char *roman_element(int Z, int J);
const char *element_name(int Z);
int element_number(const char *atom);
int roman_number(const char *roman);
